/**********************
* WARNING
* Running this code sample will cost you Browshot credits
***********************/

const browshot = require('browshot');
const fs = require("fs");

var client = new browshot('my_api_key');


var interval;

// all default parameters, instance_id = 12 (free)
client.screenshotCreate({
		url: 'http://www.google.com/', 
		instance_id: 12, 
		size: 'page'
	},
	function(screenshot) {
		// If the screenshot is already in cache, it could be finished already. Otherwise, wait longer
		if (screenshot.status == 'error') {
			console.log(`Screenshot #${screenshot.id} failed: ${screenshot.error}`);
		}
		else if (screenshot.status == 'finished') {
			screenshotFinished(screenshot);
		}
		else {
			interval = setInterval(checkScreenshot, 1000 * 10, screenshot.id);
		}
	}
);

function checkScreenshot(id) {
	client.screenshotInfo(id, { }, function(screenshot) {
		if (screenshot.status == 'error') {
			clearInterval(interval);
			
			console.log(`Screenshot #${screenshot.id} failed: ${screenshot.error}`);
		}
		else if (screenshot.status == 'finished') {
			clearInterval(interval);
			
			screenshotFinished(screenshot);
		}
		else {
			console.log(`Waiting for screenshot #${screenshot.id} to finish...`);
		}
	});
}

function screenshotFinished(screenshot) {
	// request the thumbnail
	client.screenshotThumbnail(screenshot.id, { }, function(image) {
		fs.writeFile("browshot.png", image, (err) => {
			if (err) {
				console.log(`Failed to write image to browshot.png: ${err}`);
			}
			else {
				console.log("Image saved to browshot.png");
			}
		});
	});
}
